%Tekst zadatka:
%Napisati MatLAB program za nalazenje Njutnovog interpolacionog polinoma
%sa podeljenim razlikama za aproksimaciju proizvoljne funkcije f
%zadate ili eksplicitno ili tablicno na intervalu [a, b].
%Program treba i da omogucava izracunavanje priblizne
%vrednosti funkcije u proizvoljnoj tacki intervala [a, b]
%uz izracunavanje greske. Takodje, treba da je moguce 
%resiti i problem inverzne interpolacije, to jest nalazenja
%vrednosti x za koju je dato f(x). Graficki prikazati.




function [Ln, r, v, gr] =lagrange(X, n, inter,ind,t)
format long;
if nargin~=5
    error('Funkcija zahtijeva 5 argumenata')
end
if isstr(X)
    y=X
    c=n+1;
    h=(inter(1,2)-inter(1,1))./c
    X=zeros(2, c+1);
    for k=1:c
        X(1, k)=inter(1,1)+h.*(k-1);
    end
    X(1, c+1)=inter(1,2);
    for k=1:c
        x=X(1,k);
        X(2,k)=feval(y,x);
    end
    X(2,c+1)=feval(y,inter(1,2));
else if n>(length(X(1,:)))-1
        error('za Njutnov interpolacioni polinom tog stepena nema dovoljno cvorova')
    end
    if length(X(1,:))~=length(unique(X(1,:)))
        error('svi cvorovi interpolacije moraju biti razliciti')
    end
    c=length(X(1,:));
end
X1=zeros(1,n+1);
X2=zeros(1,n+1);
for j=1:n+1
    X1(j)=X(1,j);
    X2(j)=X(2,j);
end
if (ind~=2)
D=InterpNj2(X1,X2);
Ln=[ zeros(1,n) D(1)];
for i=2:n+1
    Pn=[ 1 -X(1,1) ];
    for j=2:i-1
        Pn=conv(Pn,[1 -X(1,j)]);
    end
Ln=Ln + [zeros(1,n-i+1) D(i).*Pn] ;

end
Ln
v=polyval(Ln,t)
X1=zeros(1,n+1);
X2=zeros(1,n+1);
for j=1:n+1
    X1(j)=X(1,j);
    X2(j)=X(2,j);
end
if exist('y')
gr=abs(v- feval(y,t))
X1
polodX1=polyval(Ln,X1)
r=abs(polyval(Ln,X1)-feval(y,X1))
fplot(y,[inter(1),inter(2)],'r')
hold on
grid on
end
if exist('y')
  c=100;
    h=(inter(1,2)-inter(1,1))./c;
    X1=zeros(1, c+1);
     X2=zeros(1, c+1);
    for k=1:c
        X1(1, k)=inter(1,1)+h.*(k-1);
    end
    X1(1, c+1)=inter(1,2);
    for k=1:c
        x=X1(1,k);
        X2(1,k)=feval(y,x);
    end
    X2(1,c+1)=feval(y,inter(1,2));
plot(X1,polyval(Ln,X1))
hold off
end
end
if (ind==2)
    for s=2:n+1
        if (X2(s)<=X2(s-1)) error('Funkcija nije monotona na datom intervalu')
            
        end
    end
    D=InterpNj2(X2,X1);
Ln=[ zeros(1,n) D(1)];
for i=2:n+1
    Pn=[ 1 -X(2,1) ];
    for j=2:i-1
        Pn=conv(Pn,[1 -X(2,j)]);
    end
Ln=Ln + [zeros(1,n-i+1) D(i).*Pn] ;

end
Ln
v=polyval(Ln,t)
if exist('y')
X2
polodX2=polyval(Ln,X2)
fplot(y,[inter(1),inter(2)],'r')
hold on
grid on
end
if exist('y')
  c=100;
    h=(inter(1,2)-inter(1,1))./c;
    X1=zeros(1, c+1);
     X2=zeros(1, c+1);
    for k=1:c
        X1(1, k)=inter(1,1)+h.*(k-1);
    end
    X1(1, c+1)=inter(1,2);
    for k=1:c
        x=X1(1,k);
        X2(1,k)=feval(y,x);
    end
    X2(1,c+1)=feval(y,inter(1,2));
plot(X1,polyval(Ln,X1))
hold off
end
end

end
